;    GRDB - debugger for dos with 32-bit extensions
;    Copyright (C) 1997-2004  David Lindauer
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    (for GNU General public license see file COPYING)
;
;    you may contact the author at:  mailto::camille@bluegrass.net
; 
;    or by snail mail at:
;
;    David Lindauer
;    850 Washburn Ave.  Apt #99
;    Louisville, KY 40222
;
;
; help.asm
;
; Function: Handle help and most of the status screens
;
;   Handles numbers
;   Handles segments
;   Handles trapping page faults
;   Handles command input
;
	;MASM MODE
	.model small
	.386

include  iversion.inc
include  eprints.inc 
include  emtrap.inc 
include  eenv.inc
include  eloader.inc
include  einput.inc
include edos.inc
include eoptions.inc
include eints.inc

        extrn cpumodel : byte, w_cmdset : proc, optfs: BYTE
        public PrintVersion
	PUBLIC  help

	.data
memx	dw	0	; used to filter non-program stuff in arena dump (?m)
none	db	"none",0
cputypes db	"386",0,"486",0,"Pentium",0
	db	"Pentium Pro",0,"786",0,"886",0,"986",0
vibuf   db      13 DUP (0)
opttab  db      "FPU ",0,"VME ",0,"DE  ",0,"PSE ",0,"TSC ",0
        db      "MSR ",0,"PAE ",0,"MCE ",0,"CX8 ",0,"APIC",0,"RES1",0
        db      "SEP ",0,"MTRR",0,"PGE ",0,"MCA ",0,"CMOV",0
        db      "PAT ",0,"PSE ",0,"PSN ",0,"CLFS",0,"RES2",0,"DS  ",0
        db      "ACPI",0,"MMX ",0,"FXSR",0,"SSE ",0,"SSE2",0
        db      "SS  ",0,"HTT ",0,"TM  ",0,"RES3",0,"PBE ",0
tlbtab  db      0,"Null Descriptor",0
        db      1,"Instruction TLB, 4K/4Way/32 entries",0
        db      2,"Instruction TLB, 4M/4Way/2  entries",0
        db      3,"Data TLB, 4K/4Way/64 entries",0
        db      4,"Data TLB, 4M/4Way/8 entries",0
        db      6,"1st Lvl Instruction Cache, 8K/4Way/32 Byte",0
        db      8,"1st Lvl Instruction Cache, 16K/4Way/32 Byte",0
        db      0AH,"1st Lvl Data Cache, 8K/2Way/32 Byte",0
        db      0CH,"1st Lvl Data Cache, 16K/4Way/32 Byte",0
        db      22H,"3rd Lvl Cache, 512K/4Way/64 Byte",0
        db      23H,"3rd Lvl Cache, 1M/4Way/64 Byte",0
        db      40H,"No second, possibly no 3rd Lvl cache",0
        db      41H,"2nd Lvl Cache 128K/4Way/32 Byte",0
        db      42H,"2nd Lvl Cache 256K/4Way/32 Byte",0
        db      43H,"2nd Lvl Cache 512K/4Way/32 Byte",0
        db      44H,"2nd Lvl Cache 1M/4Way/32 Byte",0
        db      45H,"2nd Lvl Cache 2M/4Way/32 Byte",0
        db      50H,"Instruction TLB, 4K/2M or 4M/64 entries",0
        db      51H,"Instruction TLB, 4K/2M or 4M/128 entries",0
        db      52H,"Instruction TLB, 4K/2M or 4M/256 entries",0
        db      5BH,"Data TLB, 4K/4M/64 entries",0
        db      5CH,"Data TLB, 4K/4M/128 entries",0
        db      5DH,"Data TLB, 4K/4M/256 entries",0
        db      66H,"1st Lvl Data Cache, 8K/4Way/64 Byte",0
        db      67H,"1st Lvl Data Cache, 16K/4Way/64 Byte",0
        db      68H,"1st Lvl Data Cache, 32K/4Way/64 Byte",0
        db      70H,"Trace Cache, 12K/8Way",0
        db      71H,"Trace Cache, 16K/8Way",0
        db      72H,"Trace Cache, 32K/8Way",0
        db      79H,"2nd Lvl Cache 128K/8Way/Sectored/64 Byte",0
        db      7AH,"2nd Lvl Cache 256K/8Way/Sectored/64 Byte",0
        db      7CH,"2nd Lvl Cache 1M/8Way/Sectored/64 Byte",0
        db      82H,"2nd Lvl Cache 256K/8Way/32 Byte",0
        db      83H,"2nd Lvl Cache 512K/8Way/32 Byte",0
        db      84H,"2nd Lvl Cache 1M/8Way/32 Byte",0
        db      85H,"2nd Lvl Cache 2M/8Way/32 Byte",0
        db      0ffh
brandtab db     "Brand ID not supported",0
        db      "Celeron",0
        db      "Pentium III",0
        db      "Pentium III Xeon",0
        db      "Reserved",0
        db      "Reserved",0
        db      "Reserved",0
        db      "Reserved",0
        db      "Pentium 4",0
        db      "Reserved",0
        db      "Reserved",0
        db      "Reserved",0
        db      "Reserved",0
        db      "Reserved",0
        db      "Reserved",0
        db      "Reserved",0
        db      "Reserved",0
typetab db      "Original OEM",0
        db      "Intel Overdrive",0
        db      "Dual Processor",0
        db      "Reserved",0
        
	.code
;
PrintVersion PROC
	call	PrintFollowingMessage
        db      13,10,"Get Real Debugger Version "
        db      30h + verid/10,'.',30h + verid MOD 10,9
        db      "Copyright (c) 1997-2004 David Lindauer (LADSoft)",13,10
        db      0
        ret
PrintVersion ENDP
onetlb PROC
        push    cx
        cmp     al,0ffh
        jz      notlb
        or      al,al
        jz      notlb
        mov     di,offset tlbtab
otl:
        cmp     byte ptr [di],0ffh
        jz      otu
        cmp     al,[di]
        jz      otg
        inc     di
        push    ax
        sub     al,al
        mov     cx,-1
        repne   scasb
        pop     ax
        jmp     otl
otg:
        mov     bx,di
        inc     bx
        call    dgroupMessage
        call    crlf
        jmp     notlb
otu:
        PRINT_MESSAGE   <"Unknown TLB/Cache type",13,10>
notlb:
        pop     cx
        ret
onetlb ENDP
dumptlb PROC
        push    ebx
        push    ecx
        push    edx
        mov     ecx,4
dtl:
        push    eax
        call    onetlb
        pop     eax
        shr     eax,8
        loop    dtl
        pop     edx
        pop     ecx
        pop     ebx
        ret
dumptlb ENDP
;
; help command entry point
;
Help	PROC
	call	WadeSpace
	jnz	help2
ifndef NOFS
        test    [optfs],255
        jz      nofsx
        mov     al,1
        call    w_cmdset
nofsx:
endif
        call    PrintVersion
        call    PrintFollowingMessage            
        db      "a       [address]               - assemble",13,10
        db      "b[d]    [#]                     - Show breakpoint(s)",13,10
        db      "b[d]    [-]#,addr[,r/w/x[,len]] - set or clear a breakpoint",13,10
        db      "d[bwd]  [start [,end]]          - dump memory",13,10
        db      "e       start [,list]           - examine memory",13,10
        db      "g       [=start] [,break]       - run from start (or pos) to break",13,10
        db      "h       val1 [+-*/] val2        - hex arithmetic",13,10
        db      "i[bwd]  port                    - read from port",13,10
        db      "o[bwd]  port,val                - write to port",13,10
        db      "p[r]    [count]                 - step over [out]",13,10
        db      "q[s]                            - quit [save options]",13,10
        db      "r       [reg[:val]]             - show/modify regs",13,10
        db      "rf      [list of flag values]   - show/modify flags",13,10
        db      "rm      [#,val]                 - show/modify mmx regs, high byte first",13,10
        db      "rn[s]   [#, val]                - show fp regs or status, or set reg value",13,10
        db      "t       [count]                 - step into",13,10
        db      "u       [start [,end]]          - unassemble",13,10
        db      "y       [pfa [,reg[,val]]]      - read/[write] PCI reg or show devices",13,10
        db      "y?      bus, dev, func          - get PCI PFA from bus:dev:func",13,10
        db      "?                               - this help",13,10
        db      "??                              - show extended commands"
	db	0
	clc
	ret	
help2:
	cmp	al,'?'
        jnz     gnu
	inc	si
	call	wadespace
	jnz	herr
ifndef NOFS
        test    [optfs],255
        jz      nofsx1
        mov     al,1
        call    w_cmdset
nofsx1:
endif
        call    PrintVersion
	call	PrintFollowingMessage
	db	13,10
        db      "c       start,end,start2        - compare memory",13,10
        db      "f       start,end [,val]        - fill memory",13,10
        db      "l[@][-] [name[ command]]        - read from file",13,10
        db      "m       source,end,dest         - move memory",13,10
        db      "s       start,end [,list]       - search for a byte pattern",13,10
        db      "w       [@addr] [name] [,len]   - write to file",13,10
        db      "xr      drive: addr,start [,len]- read logical disk sector",13,10
        db      "xw      drive: addr,start [,len]- write logical disk sector",13,10
        db      "@[a]    [logfile]               - start/stop logging to a file [append]",13,10
        db      "?c                              - returns info about the CPU",13,10
        db      "?g[r]                           - gnu information",13,10    
        db      "?i                              - view interrupt info",13,10
        db      "?m[x]                           - view arena tags[all]",13,10
        db      "?o      [+-option list]         - view/set options",13,10
        db      "?p                              - view program status",13,10
        db      "$       [name[=[value]]]        - show,clear, or set a symbol value",13,10
        db      "$$l     [name]                  - load symbols",13,10
        db      "$$w     [name]                  - save symbols",13,10
        db      "$$$     [tablesize]             - show or set symbol table characteristics",13,10
        db      "/       instruction             - assemble and execute instruction",13,10
	db	0
	clc
	ret	
;
; program & processor info
;
gnu:
        cmp     al,'g'
        jnz     status
        inc     si
        call    wadespace
        jnz     gnuredistribute
ifndef NOFS
        test    [optfs],255
        jz      nofsx2
        mov     al,1
        call    w_cmdset
nofsx2:
endif
        call    PrintVersion
        call    PrintFollowingMessage ; warranty info
        db      13,10
        db      "    This program is distributed in the hope that it will be useful,",13,10
        db      "    but WITHOUT ANY WARRANTY; without even the implied warranty of",13,10
        db      "    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the",13,10
        db      "    GNU General Public License for more details.",13,10
        db      0
        jmp     gnujoin
        
gnuredistribute:
ifndef NOFS
        test    [optfs],255
        jz      nofsx3
        mov     al,1
        call    w_cmdset
nofsx3:
endif
        call    PrintVersion
        call    PrintFollowingMessage ; copying info
        db      13,10
        db      "    This program is free software; you can redistribute it and/or modify",13,10
        db      "    it under the terms of the GNU General Public License as published by",13,10
        db      "    the Free Software Foundation; either version 2 of the License, or",13,10
        db      "    (at your option) any later version.",13,10 
        db      0
gnujoin:
        call    PrintFollowingMessage ; copying info
        db      13,10
        db      "    You should have received a copy of the GNU General Public License",13,10
        db      "    along with this program; if not, write to the Free Software",13,10
        db      "    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA",13,10
        db      13,10
        db      "    (See the file 'COPYING' for details)",13,10
        db      0
        clc
        ret
status:
        cmp     al,'c'
        jnz     hmem2
        inc     si
        call    wadespace
        jnz     herr2
        cld
ifndef NOFS
        test    [optfs],255
        jz      nofsx7
        mov     al,1
        call    w_cmdset
nofsx7:
endif
        call    crlf
        movzx   cx,[cpumodel]
        cmp     cx,5
        jae     okcpuid
	mov	di,offset cputypes ; calculate CPU type message pos
	movzx	cx,[cpumodel]		; program needs a 386+ :)
	sub	cx,3
        jcxz    gotcpu2
	sub	al,al
cpulp2:
	push	cx
	mov 	cx,-1
	repne	scasb
	pop	cx
        loop    cpulp2

gotcpu2:
	mov	bx,di 		; put out CPU type
	call	dgroupMessage     

	call	crlf
cidx:
        clc
        ret
okcpuid:
        .586
        sub     eax,eax
        cpuid
        push    ax
        mov     dword ptr [vibuf],ebx
        mov     dword ptr [vibuf+4],edx
        mov     dword ptr [vibuf+8],ecx
        PRINT_MESSAGE <"Vendor: ">
        mov     bx,offset vibuf
        call    dgroupMessage
        pop     ax
        cmp     ax,1
        jbe     cidx
        push    ax
        mov     eax,1
        cpuid
        push    edx
        push    ebx
        push    eax
        PRINT_MESSAGE <9,"Processor Type: ">
        pop     ecx
        push    ecx
        mov     di,offset typetab
        shr     cx,12
        and     cx,3
        jcxz    ptg
ptl:
        push    cx
        mov     cx,-1
        repne   scasb
        pop     cx
        loop    ptl
ptg:
        mov     bx,di
        call    dgroupMessage
        call    crlf
        PRINT_MESSAGE <"Family: ">
        pop     eax
        push    eax
        shr     ax,8
        and     ax,15
        call    printByte
        PRINT_MESSAGE <9,9,"Extended Family: ">
        pop     eax
        push    eax
        shr     eax,20
        call    printByte
        call    crlf
        PRINT_MESSAGE <"Model: ">
        pop     eax
        push    eax
        shr     ax,4
        and     ax,15
        call    printByte
        PRINT_MESSAGE <9,9,"Extended Model: ">
        pop     eax
        push    eax
        shr     ax,16
        and     ax,15
        call    printByte
        call    crlf
        PRINT_MESSAGE <"Stepping: ">
        pop     eax
        and     ax,15
        call    printByte
        PRINT_MESSAGE <9,9,"Branding: ">
        pop     ecx
        push    ecx
        mov     di,offset brandtab
        sub     ch,ch
        jcxz    gbrnd
        sub     al,al
brndl:
        push    cx
        mov     cx,-1
        repne   scasb
        pop     cx
        loop    brndl
gbrnd:
        mov     bx,di
        call    dgroupMessage
        call    crlf
        PRINT_MESSAGE <"CLFLUSH size: ">
        pop     eax
        push    eax
        shr     ax,8
        sub     ah,ah
        call    printByte
        PRINT_MESSAGE <9,"Logical processors: ">
        pop     eax
        push    eax
        shr     eax,16
        sub     ah,ah
        call    printByte
        PRINT_MESSAGE <9,"Local APIC id: ">
        pop     eax
        shr     eax,24
        sub     ah,ah
        call    printByte
        call    crlf

        PRINT_MESSAGE <13,10,"Options:  ">
        pop     eax
        sub     ebx,ebx
olp:
        shr     eax,1
        jnc     notnow
        push    eax
        push    ebx
        lea     ebx,[ebx*4 + ebx + opttab]
        call    dgroupMessage
        mov     dl,','
        call    putchar
        pop     ebx
        pop     eax
notnow:
        inc     ebx
        cmp     ebx,32
        jl      olp
        call    crlf
        call    crlf
        pop     ax
        cmp     ax,2
        jbe     cidx
        PRINT_MESSAGE <"CACHE/TLB:",13,10>
        mov     eax,2
        cpuid
        push    eax
tlblp:
        or      al,0ffh
        test    eax,eax
        js      tlbnoeax
        call    dumptlb
tlbnoeax:
        mov     eax,ebx
        test    eax,eax
        js      tlbnoebx
        call    dumptlb
tlbnoebx:
        mov     eax,ecx
        test    eax,eax
        js      tlbnoebx
        call    dumptlb
tlbnoecx:
        mov     eax,edx
        test    eax,eax
        js      tlbnoebx
        call    dumptlb
tlbnoedx:

        pop     eax
        dec     al
        jz      tlbx
        push    eax
        mov     eax,2
        cpuid
        jmp     tlblp
tlbx:
        clc
        ret
        .386
herr2:  jmp     herr
hmem2:
	cmp	al,'p'
	jnz	hmem
	inc	si
	call	WadeSpace
	jnz	herr
ifndef NOFS
        test    [optfs],255
        jz      nofsx4
        mov     al,1
        call    w_cmdset
nofsx4:
endif
	PRINT_MESSAGE	<13,10,"Dos version: ">
	mov	al,byte ptr [dosver + 1]
	call	printbyte
	mov	dl,'.'
	call	putchar
	mov	al,byte ptr [dosver]
	call	printbyte
;        PRINT_MESSAGE   <13,10,"CPU type: ">
;        mov     di,offset cputypes ; calculate CPU type message pos
;        movzx   cx,[cpumodel]           ; program needs a 386+ :)
;        sub     cx,3
;        jcxz    gotcpu
;        sub     al,al
;cpulp:
;        push    cx
;        mov     cx,-1
;        repne   scasb
;        pop     cx
;        loop    cpulp

;gotcpu:
;        mov     bx,di           ; put out CPU type
;        call    dgroupMessage     

        call    crlf

	mov	si,offset loadfile	; calc loadfile and command
	mov	di,offset loadcommand
	test	[filelen],-1
	jnz	okprog
	mov	si,offset none
	mov	di,si
okprog:
	test	byte ptr [di],-1
	jnz	okgotdi
	mov	di,offset none
okgotdi:
	test	byte ptr [si],-1
	jnz	okgotsi
	mov	si,offset none
okgotsi:
	PRINT_MESSAGE	<13,10,"Program:   ">
	mov	bx,si
	call	DgroupMessage
	PRINT_MESSAGE	<13,10,"Arguments: ">
	mov	bx,di
	call	DgroupMessage
	call	ExeStats			; put out EXE file stats
	call	crlf

	PRINT_MESSAGE	<13,10,"Psp at ">
	mov	ax,[userbasepsp]
	call	PrintWord
	mov	ax,[userpsp]
	cmp	ax,[userbasepsp]
	jz	normpsp
	push	ax              		; display if they have changed it
	call	printspace
	mov	dl,'('
	call	PutChar
	pop	ax
	call	PrintWord
	mov	dl,')'
	call	PutChar
	call	printspace
normpsp:
	PRINT_MESSAGE	<" with length ">
	mov	ax,[userbasepsp]
	dec	ax
	mov	fs,ax
	mov	ax,fs:[3]
	call	PrintWord
	PRINT_MESSAGE	<13,10,"Environment at ">
	mov	ax,[TgtPgmEnvSeg]
	call	PrintWord
	PRINT_MESSAGE	<" with ">
	mov	ax,[TgtPgmEnvSpaceUsed]
	call	Printword
	PRINT_MESSAGE	<" bytes used of ">
	mov	ax,[TgtPgmEnvLen]
	call	PrintWord
	
	clc
	ret		
;
; arena stats
;
hmem:	cmp	al,'m'
	jnz	hopt
ifndef NOFS
        test    [optfs],255
        jz      nofsx5
        mov     al,1
        call    w_cmdset
nofsx5:
endif
	mov	ax,[userbasepsp]		; calc PSP match
	mov	[memx],ax
	inc	si
	call	WadeSpace
	jz	memok
	cmp	al,'x'
	jnz	herr
	inc	si
	call	WadeSpace
	jnz	herr
	mov	[memx],0
memok:
	PRINT_MESSAGE	<13,10,13,10,"Top of memory: ">
	mov	fs,[userbasepsp]
	mov	ax,fs:[2]
	call	PrintWord
	call	crlf
	push	es 				; get root of chain      			
	mov	ah,52h	
	int	21h
	mov	bx,es:[bx-2]
	pop	es
meml:
	mov	fs,bx
	test	[memx],0ffffh			; check match and jump around if not
	jz	memd
	mov	ax,fs:[1]
	cmp	ax,[memx]
	jnz	memnd
memd:
	PRINT_MESSAGE	<13,10,"Address: ">
	mov	ax,fs
	call	PrintWord
	PRINT_MESSAGE	<"  Owner: ">
	test	word ptr fs:[1],-1
	jz	memu
	cmp	word ptr fs:[1],100h
	jc	memdos
	cmp	word ptr fs:[1],0f000h
	jnc	membios
	push	fs    				; not special
	mov	bx,fs:[1]			; display prog name owner
	dec	bx
	mov	fs,bx
	mov	si,8
	mov	cx,8
memns:
	lods	byte ptr fs:[si]
	or	al,al
	jz	memnsx
	mov	dl,al
	call	PutChar
	loop	memns
memnsx:
	pop	fs
	inc	cx
	push	cx
	mov	dl,'('
	call	PutChar
	mov	ax,fs:[1]
	call	PrintWord
	mov	dl,')'
	call	PutChar
	jmp	memsz
memdos:                                         ; dos special case
	push	12
	PRINT_MESSAGE	"DOS"
	jmp	memmsg
membios:					; bios special case
	push	11
	PRINT_MESSAGE	"BIOS"
	jmp	memmsg

memu:						; free special case
	push	11
	PRINT_MESSAGE	"FREE"
memmsg:
memsz:
	pop	cx
memspl:
	mov	dl,' '				; field pad
	push	cx
	call	PutChar
	pop	cx
	loop	memspl
	PRINT_MESSAGE	"  Size: "
	mov	ax,fs:[3]
	call	PrintWord
	mov	bx,fs
memnd:
	add	bx,fs:[3]			; index to next entry
	inc	bx
	cmp	byte ptr fs:[0],'Z'		; quit if this entry was EOM
	jnz	meml
	clc
	ret
;
; option status, jump to option routine
;
hopt:
	cmp	al,'o'
	jnz	hchain
	inc	si
	jmp	doopt
;
; chain status
;
hchain:
	cmp	al,'i'
	jnz	herr
	inc	si
	call	wadespace
	jnz	herr
ifndef NOFS
        test    [optfs],255
        jz      nofsx6
        mov     al,1
        call    w_cmdset
nofsx6:
endif
	inc	si
	call	crlf
	push	es
	mov	es,[intpage]
	sub	ax,ax
	mov	gs,ax
	mov	cx,256
	sub	si,si
	sub	di,di
chl:
	lods	dword ptr gs:[si]	; compare currint int page entry
	scasd
	jz	noch
	push	si
	push	di
	push	eax			; mismatch, print int #
	mov	al,cl
	neg	al
	push	ax
	call	printbyte
	pop	ax
	cmp	al,21h			; int 21h is modifiable
	jz	nostar
	or	al,al 			; so are all ints > 7FH
	js	nostar
	push	es
	push	ds
	pop	es
	mov	di,offset veclist
chlx:
	scasb
	jz	dostar
	inc	di
	inc	di
	cmp	byte ptr [di],0ffh
	jnz	chlx
	pop	es
nostar:
	call	printspace		; not overridden
	jmp	chj
dostar:
	pop	es
	mov	dl,'*'
	call	putchar
chj:                                    ; print int vect address
	mov	dl,':'
	call	putchar
	call	printspace
	pop	bx
	pop	ax
	call	printword
	mov	dl,':'
	call	putchar
	mov	ax,bx
	call	printword
	call	crlf
	pop	di
	pop	si
noch:
	loop	chl
	pop	es
	PRINT_MESSAGE	<13,10,"PIC 0 mask: ">
	mov	dx,21h
	mov	ah,byte ptr [orgpic+1]
	call	picval
	PRINT_MESSAGE	<13,10,"PIC 1 mask: ">
	mov	dx,0a1h
	mov	ah,byte ptr [orgpic]
	call	picval
	clc
	ret
picval:
	push	ax
	in	al,dx
	push	dx
	call	printbyte
	call	printspace
	mov	dl,'(' 
	call	putchar
	pop	dx
	pop	ax
	push	dx
	mov	al,ah
	call	printbyte
	mov	dl,',' 
	call	putchar
	pop	dx
	dec	dx
	mov	al,0bh
	out	dx,al
	in	al,dx
	call	printbyte
	mov	dl,')' 
	call	putchar
	ret
herr:
	stc
	ret
Help	ENDP
END
